"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var path = require("path");
var name = 'webpack-glsl-loader';
function parse(loader, source, context, cb) {
    var imports = [];
    var importPattern = /@import ([.\/\w_-]+);/gi;
    var match = importPattern.exec(source);
    while (match != null) {
        imports.push({
            key: match[1],
            target: match[0],
            content: '',
        });
        match = importPattern.exec(source);
    }
    processImports(loader, source, context, imports, cb);
}
function processImports(loader, source, context, imports, cb) {
    if (imports.length === 0) {
        return cb(null, source);
    }
    var imp = imports.pop();
    loader.resolve(context, imp.key + ".glsl", function (err, resolved) {
        if (err) {
            return cb(err);
        }
        loader.addDependency(resolved);
        fs.readFile(resolved, 'utf-8', function (err, src) {
            if (err) {
                return cb(err);
            }
            parse(loader, src, path.dirname(resolved), function (err, bld) {
                if (err) {
                    return cb(err);
                }
                var newSource = source.replace(imp.target, bld);
                processImports(loader, newSource, context, imports, cb);
            });
        });
    });
}
function default_1(source) {
    this.cacheable();
    var cb = this.async();
    parse(this, source, this.context, function (err, bld) {
        if (err)
            return cb(err);
        cb(null, "export default " + JSON.stringify(bld));
    });
}
exports.default = default_1;
